@if (!edit) {
  <div
    class="flex-row full-height full-width"
    [ngClass]="getComponentClasses()"
    (click)="enableEditMode()"
  >
    @if (value && isObfuscated) {
      {{ obfuscatedText }}
    } @else {
      @if (value) {
        <span
          [ngClass]="cssClasses"
          nz-tooltip
          [sqtmCoreLabelTooltip]="value"
          [ellipsis]="true"
        >
          {{ value }}
        </span>
      } @else {
        @if (editable && showPlaceHolder) {
          <span class="sqtm-placeholder">
            {{
              !!placeholder
                ? placeholder
                : ('sqtm-core.generic.editable.placeholder' | translate)
            }}
          </span>
        }
        @if (editable && displayInGrid) {
          <div class="full-width grid-icon">
            <span><i nz-icon nzType="edit" nzTheme="outline"></i></span>
          </div>
        }
      }
    }
    @if (editable) {
      <i
        class="pencil-icon flex-fixed-size"
        nz-icon
        [nzType]="getEditableIcon()"
        nzTheme="outline"
      ></i>
    }
  </div>
}
@if (edit) {
  <div class="flex-column" [ngClass]="getComponentClasses()">
    <div class="flex full-width full-height" style="align-items: center">
      <input
        #input
        nz-input
        [type]="isObfuscated ? 'password' : 'text'"
        [ngClass]="getInputFieldCss()"
        [formControl]="formControl"
        (blur)="handleBlur($event)"
        (keyup)="handleKeyboardInput($event)"
        [nzSize]="size"
        (mousedown)="stopMouseEventPropagation($event)"
      />
      @if (mustShowButtons()) {
        <button
          [attr.data-test-button-id]="'textfield-confirm-btn'"
          nz-button
          nzType="primary"
          class="editable-text-field-confirm-button"
          [ngClass]="getConfirmButtonCss()"
          [nzSize]="size"
          [disabled]="dirty && formControl.errors"
          [nzLoading]="pending"
          (click)="confirm()"
        >
          <i nz-icon [nzType]="'check'"></i>
          @if (mustShowButtonLabels()) {
            {{ 'sqtm-core.generic.label.confirm' | translate | capitalize }}
          }
        </button>
        <button
          [attr.data-test-button-id]="'textfield-cancel-btn'"
          nz-button
          nzType="default"
          [nzSize]="size"
          class="editable-text-field-cancel-button"
          [ngClass]="getCancelButtonCss()"
          [nzLoading]="pending"
          (click)="cancel()"
        >
          <i nz-icon [nzType]="'close'"></i>
          @if (mustShowButtonLabels()) {
            {{ 'sqtm-core.generic.label.cancel' | translate | capitalize }}
          }
        </button>
      }
    </div>
    @if (dirty && formControl.errors) {
      <div class="flex-column full-width has-error m-t-2">
        @for (error of getErrors(formControl.errors); track error) {
          <span class="sqtm-core-error-message">{{ error }}</span>
        }
      </div>
    }
    @if (dirty && externalErrors.length > 0) {
      <div class="flex-column full-width has-error m-t-2">
        @for (error of externalErrors; track error) {
          <span class="sqtm-core-error-message">{{ error }}</span>
        }
      </div>
    }
  </div>
}
